//+------------------------------------------------------------------+
//|                                                       SumXMA.mq5 |
//|                                        Copyright  2008, jax1000 |
//|                                                  jax1000@list.ru |
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2008, jax1000"
//----  
#property link      "jax1000@list.ru"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 1
//----    
#property indicator_plots   1
//+----------------------------------------------+
//|     Cycle        |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----        SlateBlue 
#property indicator_color1  clrSlateBlue
//----   1 -  
#property indicator_style1  STYLE_SOLID
//----    1  3
#property indicator_width1  3
//----    
#property indicator_label1  "SumXMA"
//+----------------------------------------------+
//|    CXMA                        |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA[];
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Smooth_Method XMA_Method=MODE_SMA; // 
input uint StartLength=20; //  
input uint EndLength=100; //                    
input int XPhase=15; // ,
                     // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
input int Shift=0; //      
input int PriceShift=0; // c     
//+----------------------------------------------+

//----   ,    
//      
double SumXMABuffer[];

bool Init;
//----      
int min_rates_total,xSize;
//----      
double dPriceShift;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----       
   if(StartLength>EndLength)
     {
      Init=false;
      Print("        !");
      return;
     }

//----     
   xSize=int(EndLength-StartLength+1);

   if(ArrayResize(XMA,xSize)<xSize)
     {
      Init=false;
      Print("       XMA[]!");
      return;
     }
   else Init=true;

//----     
   min_rates_total=XMA[0].GetStartBars(XMA_Method,EndLength,XPhase);
//----       
   XMA[0].XMAPhaseCheck("XPhase",XPhase,XMA_Method);
//----    
   dPriceShift=_Point*PriceShift;

//----      
   SetIndexBuffer(0,SumXMABuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----        min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(SumXMABuffer,true);

//----      
   string Smooth=XMA[0].GetString_MA_Method(XMA_Method);
   string shortname;
   StringConcatenate(shortname,"SumXMA(",Smooth,", ",StartLength,", ",EndLength,", ",XPhase,", ",Shift,", ",PriceShift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const int begin,          //     
                const double &price[]     //     
                )
  {
//----       
   if(!Init || rates_total+begin<min_rates_total) return(0);

//----    
   int MaxBar,limit,bar;
   double Sum;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_total-1-begin; //      

      //----        min_rates_total+begin
      PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total+begin);
     }
   else limit=rates_total-prev_calculated; //      

   MaxBar=rates_total-min_rates_total-1-begin;

//----         
   ArraySetAsSeries(price,true);

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      Sum=0.0;
      for(int number=0; number<xSize; number++)
         Sum+=XMA[number].XMASeries(MaxBar,prev_calculated,rates_total,XMA_Method,XPhase,StartLength+number,price[bar],bar,true);

      SumXMABuffer[bar]=Sum/(EndLength-StartLength+1)+dPriceShift;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
